function [imgs_new] = align(imgs, offset)
%ALIGN Summary of this function goes here
%   Detailed explanation goes here

% original rectangle
a      = ones(2,4);
a(2,2) = size(imgs,2);
a(1,3) = size(imgs,1);
a(:,4) = [size(imgs,1) size(imgs,2)];

% modified rectangle
am = a;

% calculate overlaps and save to am
ap = zeros(2,4);
for i=2:size(imgs,3)
    % new rectangle with offsets
    ap(1,:) = a(1,:) + offset(1,i);
    ap(2,:) = a(2,:) + offset(2,i);
    
    % compare current modified and new rectangle
    % prime over mod?
    if ap(1,1) < am(1,1)
        am(1,3) = ap(1,3);
        am(1,4) = ap(1,4);
    else
        am(1,1) = ap(1,1);
        am(1,2) = ap(1,2);
    end    
    % prime left of mod?
    if ap(2,1) < am(2,1)
        am(2,2) = ap(2,2);
        am(2,4) = ap(2,4);
    else
        am(2,1) = ap(2,1);
        am(2,3) = ap(2,3);
    end
end

% apply offsets and overlap
x_from = max(1,am(1,1));
x_to   = min(a(1,3),am(1,3));
y_from = max(1,am(2,1));
y_to   = min(a(2,2),am(2,2)); 
imgs_new = zeros(x_to-x_from+1,y_to-y_from+1,size(imgs,3));
for i=1:size(imgs,3)
    x_from = am(1,1) - offset(1,i);
    x_to   = am(1,3) - offset(1,i);
    y_from = am(2,1) - offset(2,i);
    y_to   = am(2,2) - offset(2,i);
    imgs_new(:,:,i) = imgs(x_from:x_to,y_from:y_to,i);
end


end

