%close all;

% samples
samples = 10;


% files and pixels
files      = dir('img_0*.tif');
n          = size(files, 1);
resolution = size(imread(files(1).name));
pixels     = zeros(samples, n);
t          = zeros(n,1);

% concrete samples
offset   = 200;
concrete1 = 1:offset:resolution(1);
concrete2 = 1:offset:resolution(2);


blackIm = imread('img_black.tif');


for i=1:n    
    filename = files(i).name;
    I        = imread(filename) - blackIm;
    t(i)     = strread(filename, 'img_%d.tif');
    %figure; hold on
    for j=1:length(concrete1)
        for k=1:length(concrete2)
            pixels(j,k,i) = I(concrete1(j), concrete2(k));
        end
    end
end

colors = ['r' 'b' 'g' 'c' 'k'];
figure; hold on;
for j=5:9
    for k=5:9
        plot(log(squeeze(pixels(j,k,:))), log(t(:)), [colors(j-4) ''])
    end
end

%%

s = 0:.1:100

%plot(s, s*2); hold on

plot(s, log(s*2))