%clear all;
close all;
% files in folder
files = dir('img*.tif');
n     = size(files, 1);

% scale factors
bits_max = 2^16-1;
dark_current = double(imread('dark_current.tif'));

if 0<n
    % get resolution
    tmp          = imread(files(1).name);
    [resx, resy] = size(tmp);   
    clearvars tmp;

    % sequences from files
    seq = cellstr('');
    j   = 1;
    for i=1:n
        fn    = files(i).name;
        space = strfind(fn, '_');
        s_seq = substr(fn, 1, space-1);
        % check if sequence already there store else    
        if ismember(seq, s_seq)==0
            seq(j) = {s_seq};
            j = j+1;
        end
    end
    
    % read images for one sequence and do something
    for i=1:length(seq)
        cnt = 0;
        % read images from sequence into imgArray
        imgArray  = double(zeros(resx, resy, 1));
        exposures = zeros(1);

        for j=1:n
            fn    = files(j).name;
            space = strfind(fn, '_');
            s_seq = substr(fn, 1, space-1);
            if strcmp(s_seq,seq(i));
                cnt = cnt+1;
                % read the image, substract the dark current of the sensor
                imgArray(:, :, cnt) = double(imread(fn));% - dark_current; 
                % save exposure
                exposures(cnt)      = str2num(substr(fn, strfind(fn,'_')+1, strfind(fn,'.')-1-length(fn)));                
            end
        end
        
        % align all
        offsets         = mtb(imgArray, 128);
        imgArray        = align(imgArray, offsets);
        hdrArray(:,:,i) = ldr_to_hdr(imgArray, exposures, bits_max);
    end
end