clear all;
% random pixels in the images
%r(1,:)     = randi(resolution(1),1,30);
%r(2,:)     = randi(resolution(2),1,30);

% for reproduction use these
r = [1385, 2522, 1704, 2559, 644,  1807, 773, 1796, 1858, 182,  681,  599,  1785, 2257, 921, 2086, 1805,18,1609,1034,2448,4,1236,1134,1232,2058,862,2097,1260,96;
     705,  2893, 1898, 613,  1368, 2435, 769, 2960, 974,  3678, 1079, 3069, 757,  1153, 366, 2310, 2739,2191,1707,2583,2596,2722,2549,3789,838,2843,947,479,2435,1805];

% samples
samples = 30;

% images
files      = dir('imgi_0*.tif');
% how many images
n          = size(files, 1);
% resolution of the images
resolution = size(imread(files(1).name));
% exposure time of the images
t          = zeros(n,1);
for i=1:n    
    filename = files(i).name;
    t(i)     = strread(filename, 'imgi_%d.tif');
end

% add other files
files2 = dir('imgi*.tif');
n      = size(files2, 1);

pixels = zeros(33,30);

for i=1:n    
    filename = files2(i).name;
    I        = imread(filename);
         
    %figure; hold on
    for j=1:samples
        pixels(i,j) = I(r(1,j), r(2,j));
    end
end

% add to one array
pixels2 = zeros(n/3, samples*3);
pixels2(:,1:30)  = pixels(1:11,1:30);
pixels2(:,31:60) = pixels(12:22,1:30);
pixels2(:,61:90) = pixels(23:33,1:30);

% figure; hold on;
% for j=1:samples*3
%     plot(log(pixels2(:,j)), log(t(:)));
% end

% take good values from image range 3000 to 6700
% this values are selected by manual selection
% save to pixels3 to collect as array
i = 0;
for j=1:samples*3;
    if 3000 < pixels2(1,j) && pixels2(1,j) < 6700
        i=i+1;
        pixels3(:,i) = pixels2(:,j); 
    end
end

% plot all lines
figure; hold on;
for j=1:length(pixels3)
    plot(log(pixels3(:,j)), log(t(:)));
end

[m,n] = size(pixels3);

A_tmp    = log(reshape(pixels3,m*n,1));
b        = log(t);
A        = ones(11,2);
logr_fnc = zeros(2, 1);

% build les and save to r_fnc
for i=1:n;
    A(:,1)      = A_tmp(i*11-10:i*11);
    x           = A\b;
    logr_fnc(1) = logr_fnc(1) + x(1);
    logr_fnc(2) = logr_fnc(2) + x(2);
end

% build average of all result
logr_fnc = logr_fnc ./ n;
% plot logarithmic reponse function g
plot(8:.1:12, logr_fnc(1) * (8:.1:12) + logr_fnc(2), 'r');

% try again
A       = ones(m*n, 2);
A(:, 1) = log(reshape(pixels3,m*n,1));
b       = repmat(log(t), n, 1);
r_fnc   = A\b;
plot(8:.1:12, r_fnc(1) * (8:.1:12) + r_fnc(2), 'g');




